# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#import lib.proxy
import conf.null

from lib.splash import SplashWindow
SplashWindow.pulse_text_import("conf.base")

import gtk

class PropertyBase(conf.null.NullProperty):
    """
    It's a base class for all clases inserted in preferences box. You can't insert any class
    to preferences box without inheriting this base class.
    """
    def __init__(self, short_desc):
        """Konstruktor"""
        super(PropertyBase, self).__init__()
        label = gtk.Label(short_desc)
        label.set_alignment(0.0, 0.0)
        label.show()
        gtk.VBox.pack_start(self, label, False, False, 5)
        separator = gtk.HSeparator()
        separator.show()
        gtk.VBox.pack_start(self, separator, False, False, 2)
        self.vbox = gtk.VBox()
        self.vbox.show()
        scroll = gtk.ScrolledWindow()
        scroll.show()
        scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        viewport = gtk.Viewport()
        viewport.show()
        viewport.add(self.vbox)
        scroll.add(viewport)
        gtk.VBox.pack_start(self, scroll, True, True, 0)
        separator = gtk.HSeparator()
        separator.show()
        gtk.VBox.pack_start(self, separator, False, False, 2)
        hbox = gtk.HButtonBox()
        hbox.set_layout(gtk.BUTTONBOX_END)
        hbox.show()
        self.apply_button = gtk.Button(_("Apply"), 'gtk-apply')
        self.apply_button.show()
        self.apply_button.connect("clicked", self.apply_clicked)
        hbox.pack_start(self.apply_button, False, False, 0)
        gtk.VBox.pack_start(self, hbox, False, False, 5)
    def pack_start(self, child, expand=True, fill=True, padding=0):
        """Look at gtk.VBox.pack_start"""
        self.vbox.pack_start(child, expand, fill, padding)
