# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import conf.base
import lib.config
import widget.combobox

from lib.splash import SplashWindow
SplashWindow.pulse_text_import("conf.editor.general")

import gtk

class GeneralProperty(conf.base.PropertyBase):
    encoding = 'iso8859-2'
    cursor_shape = 0
    def __init__(self):
        """Konstruktor"""
	conf.base.PropertyBase.__init__(self, _("General preferences"))
	self.config_file = lib.config.ConfigureSection(self, 'Editor.General')
	self.read_config()
        table = gtk.Table(3, 2, True)
        table.show()
        ##############################################################
        label = gtk.Label(_("Default text encoding :"))
        label.show()
        table.attach(label, 0, 1, 0, 1)
        table.set_row_spacings(2)
        self.combobox = widget.combobox.EncComboBox()
        self.combobox.show()
        self.combobox.set_active(GeneralProperty.encoding)
        table.attach(self.combobox, 1, 2, 0, 1)
        self.pack_start(table, False, False, 5)
        ###############################################################
        label = gtk.Label(_("Cursor shape :"))
        label.show()
        table.attach(label, 0, 1 , 1, 2)
        self.combobox_cursor = gtk.combo_box_new_text()
        self.combobox_cursor.show()
        self.combobox_cursor.append_text(_("Block"))
        self.combobox_cursor.append_text(_("Horizontal line"))
        self.combobox_cursor.append_text(_("Vertical line"))
        self.combobox_cursor.set_active(GeneralProperty.cursor_shape)
        table.attach(self.combobox_cursor, 1, 2, 1, 2)
        ###############################################################
    def apply_clicked(self, button, data=None):
	GeneralProperty.encoding = self.combobox.get_active()
        GeneralProperty.cursor_shape = self.combobox_cursor.get_active()
    def read_config(self):
	if self.config_file.has_option('Encoding'):
	    GeneralProperty.encoding = self.config_file.get('Encoding')
        if self.config_file.has_option('CursorShape'):
            GeneralProperty.cursor_shape = self.config_file.get_int('CursorShape')
    def update_config(self):
	self.config_file.set('Encoding', GeneralProperty.encoding)
        self.config_file.set('CursorShape', GeneralProperty.cursor_shape)
