# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import lib.config
import conf.base

from lib.splash import SplashWindow
SplashWindow.pulse_text_import("conf.editor.indent")

import gtk

class IndentProperty(conf.base.PropertyBase):
    indent_width = 4
    tab_width = 8
    replace_tabs = False
    def __init__(self):
        """Konstruktor"""
	conf.base.PropertyBase.__init__(self, _("Indentation preferences"))
	self.config_file = lib.config.ConfigureSection(self, 'Editor.Indent')
	self.read_config()
        table = gtk.Table(2, 4)
        table.set_row_spacings(4)
        table.show()
        #---------
        self.t_check = gtk.CheckButton(_("Replace tabs by space"))
        self.t_check.set_active(IndentProperty.replace_tabs)
        self.t_check.show()
        table.attach(self.t_check, 0, 2, 0, 1, xoptions=gtk.FILL, xpadding=10)
        #---------
        label = gtk.Label(_("Indent width : "))
        label.show()
        label.set_alignment(0.0 , 0.5)
        table.attach(label, 0, 1, 1, 2, xoptions=gtk.FILL, xpadding=10)
        self.i_spin = gtk.SpinButton(None)
        self.i_spin.set_range(0, 20)
        self.i_spin.set_increments(1, 5)
        self.i_spin.set_value(IndentProperty.indent_width)
        self.i_spin.show()
        table.attach(self.i_spin, 1, 2, 1, 2, xoptions=gtk.FILL)
        #---------
        label = gtk.Label(_("Tab width : "))
        label.set_alignment(0.0, 0.5)
        label.show()
        table.attach(label, 0, 1, 2, 3, xoptions=gtk.FILL, xpadding=10)
        self.t_spin = gtk.SpinButton(None)
        self.t_spin.set_range(0, 20)
        self.t_spin.set_increments(1, 5)
        self.t_spin.set_value(IndentProperty.tab_width)
        self.t_spin.show()
        table.attach(self.t_spin, 1, 2, 2, 3, xoptions=gtk.FILL)
        self.pack_start(table, False, False, 0)
    def show_widget(self):
        pass
    def apply_clicked(self, button, data=None):
        IndentProperty.indent_width = int(self.i_spin.get_value())
        IndentProperty.tab_width = int(self.t_spin.get_value())
        IndentProperty.replace_tabs = self.t_check.get_active()
    def read_config(self):
        if self.config_file.has_option('Indent Width'):
            IndentProperty.indent_width = self.config_file.get_int('Indent Width')
        if self.config_file.has_option('Tab Width'):
            IndentProperty.tab_width = self.config_file.get_int('Tab Width')
        if self.config_file.has_option('Replace Tabs'):
            IndentProperty.replace_tabs = self.config_file.get_bool('Replace Tabs')
    def update_config(self):
        self.config_file.set('Indent Width', IndentProperty.indent_width)
        self.config_file.set('Tab Width', IndentProperty.tab_width)
        self.config_file.set('Replace Tabs', IndentProperty.replace_tabs)
