# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import conf.base
import widget.colorselection
import lib.config

from lib.splash import SplashWindow
SplashWindow.pulse_text_import("conf.editor.lineview")

import gtk
import pango

class LineviewProperty(conf.base.PropertyBase):
    enabled          = True
    text_color       = gtk.gdk.colormap_get_system().alloc_color(0,     0,     0    )
    background_color = gtk.gdk.colormap_get_system().alloc_color(30600, 30600, 30600)
    font_weight      = pango.WEIGHT_NORMAL
    font_style       = pango.STYLE_NORMAL
    def __init__(self):
        conf.base.PropertyBase.__init__(self, 'Lineview preferences')
        self.config_file = lib.config.ConfigureSection(self, 'Editor.Lineview')
        self.read_config()
        self.toggle = gtk.CheckButton(_('Show line numbers'))
	self.toggle.set_active(LineviewProperty.enabled)
	self.toggle.show()
	self.toggle.connect('toggled', self.enable_toggled)
	self.pack_start(self.toggle, False, False, 0)
	self.frame = gtk.Frame(_('Font style'))
	self.frame.show()
	hbox = gtk.HBox()
	hbox.show()
	self.button_bold = gtk.CheckButton(_('Bold'))
	self.button_bold.show()
	if LineviewProperty.font_weight==pango.WEIGHT_BOLD:
	    self.button_bold.set_active(True)
	hbox.pack_start(self.button_bold, True, True, 0)
	self.button_italic = gtk.CheckButton(_('Italic'))
	if LineviewProperty.font_style==pango.STYLE_ITALIC:
	    self.button_italic.set_active(True)
	self.button_italic.show()
	hbox.pack_start(self.button_italic, True, True, 0)
	self.frame.add(hbox)
	self.pack_start(self.frame, False, True, 0)
        self.select = widget.colorselection.ColorSelectionBox()
        self.select.show()
        self.pack_start(self.select, True, True, 0)
        self.select.append_text("TextColor", LineviewProperty.text_color)
        self.select.append_text("BackgroundColor", LineviewProperty.background_color)
        self.enable_toggled()
    def enable_toggled(self, widget=None, data=None):
	enabled = self.toggle.get_active()
	self.frame.set_sensitive(enabled)
	self.select.set_sensitive(enabled)
    def close_widget(self):
        self.select.reset_color()
    def apply_clicked(self, button, data=None):
        LineviewProperty.enabled = self.toggle.get_active()
        if LineviewProperty.enabled:
            self.select.apply_current_color()
            LineviewProperty.text_color = self.select.get_current_color(0)
            LineviewProperty.background_color = self.select.get_current_color(1)
            if self.button_bold.get_active():
                LineviewProperty.font_weight = pango.WEIGHT_BOLD
            else:
                LineviewProperty.font_weight = pango.WEIGHT_NORMAL
            if self.button_italic.get_active():
                LineviewProperty.font_style = pango.STYLE_ITALIC
            else:
                LineviewProperty.font_style = pango.STYLE_NORMAL
    def update_config(self):
	self.config_file.set('Enabled', LineviewProperty.enabled)
	color = '#%02X%02X%02X' % (LineviewProperty.text_color.red/257,
	    LineviewProperty.text_color.green/257,
	    LineviewProperty.text_color.blue/257)
	self.config_file.set('Textcolor', color)
	color = '#%02X%02X%02X' % (LineviewProperty.background_color.red/257,
	    LineviewProperty.background_color.green/257,
	    LineviewProperty.background_color.blue/257)
	self.config_file.set('Backgroundcolor', color)
        if LineviewProperty.font_style==pango.STYLE_ITALIC:
	    self.config_file.set('Italic_font', 'True')
        else:
            self.config_file.set('Italic_font', 'False')
        if LineviewProperty.font_weight==pango.WEIGHT_BOLD:
	    self.config_file.set('Bold_font', 'True')
        else:
            self.config_file.set('Bold_font', 'False')
    def read_config(self):
	if self.config_file.has_option('Backgroundcolor'):
	    color = self.config_file.get('Backgroundcolor')
	    LineviewProperty.background_color = self.get_colormap().alloc_color(gtk.gdk.color_parse(color))
        if self.config_file.has_option('Textcolor'):
	    color = self.config_file.get('Textcolor')
	    LineviewProperty.text_color = self.get_colormap().alloc_color(gtk.gdk.color_parse(color))
	if self.config_file.has_option('Enabled'):
	    if self.config_file.get('Enabled')=='True':
		LineviewProperty.enabled = True
	    else:
		LineviewProperty.enabled = False
	if self.config_file.has_option('Italic_font'):
	    if self.config_file.get('Italic_font')=='True':
		LineviewProperty.font_style = pango.STYLE_ITALIC
	if self.config_file.has_option('Bold_font'):
	    if self.config_file.get('Bold_font')=='True':
		LineviewProperty.font_weight = pango.WEIGHT_BOLD	
