# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import gui.main_app
import gui.menu
import gui.toolbar
import gui.plugintoolbar
import gui.hpaned
import widget.notebook
import conf.preferences
import lib.pluglist

import widget.buttons #test

from lib.splash import SplashWindow
SplashWindow.pulse_text_import("gui.main_gui")

import gtk

import gui.tooltips

def init_gui():
    """Funkcja ta tworzy zmienne globalne do widget'ow uzywanych w glownym oknie programu."""
    global app
    global vbox
    global menu
    global toolbar
    global hbox
    global plugintoolbar
    global hpaned
    global notebook
    global statusbar
    global preferences
        
    gui.tooltips.init_tips()
    
    # Application
    SplashWindow.pulse_text("Initing gui: main window")
    app = gui.main_app.Application()
    # main_vbox
    vbox = gtk.VBox(False, 0)
    vbox.show()

    ## main_menu
    SplashWindow.pulse_text("Initing gui: menu")
    menu = gui.menu.MenuBar()
    menu.show()
    ## main_toolbar
    SplashWindow.pulse_text("Initing gui: toolbar")
    toolbar = gui.toolbar.MainToolBar()
    toolbar.show()
    ## main_hbox
    hbox = gtk.HBox()
    hbox.show()
    ### plugintoolbar
    SplashWindow.pulse_text("Initing gui: plugintoolbar")
    plugintoolbar = gui.plugintoolbar.PluginToolBar()
    plugintoolbar.show()
    ### hpaned
    hpaned = gui.hpaned.HPaned() #gtk.HPaned()
    hpaned.show()
    ### notebook
    SplashWindow.pulse_text("Initing gui: notebook")
    notebook = widget.notebook.NoteBook()
    notebook.show()
    ## statusbar
    SplashWindow.pulse_text("Initing gui: statusbar")
    statusbar = gtk.Statusbar()
    statusbar.show()
    # Preferences dialog
    SplashWindow.pulse_text("Initing gui: preferences")
    preferences = conf.preferences.PreferencesBox()
    preferences.show()
    # Loading plugins
    lib.pluglist.load_plugins() # plugin class constructor cause adding the widget to the plugintoolbar
    if len(lib.pluglist.list)==0:
        plugintoolbar.hide()
