# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#	Note:		You must reply to the verification e-mail to get through.
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import graph.xpm
import widget.menus
import widget.terminal
import gui.callbacks

from lib.splash import SplashWindow
SplashWindow.pulse_text_import("gui.toolbar")

import gtk
	
class MainToolBar(widget.menus.ToolBar):
    def __init__(self):
	super(MainToolBar, self).__init__()
	self.fullscreen = False
	self.set_style(gtk.TOOLBAR_BOTH)
        self.create_item("gtk-new", _("New file"), gui.callbacks.new_file_clicked)
        self.create_item("gtk-open", _("Open file"), gui.callbacks.open_file_clicked)
        self.create_item("gtk-save", _("Save file"), gui.callbacks.save_file_clicked)
        self.create_item("gtk-save-as", _("Save file as"), gui.callbacks.save_file_as_clicked)
        self.create_xpmitem(graph.xpm.XPMSaveAll, _("Save all files"), gui.callbacks.save_all_files_clicked)
        self.create_separator()
        self.create_item("gtk-fullscreen", _("Fullscreen"), gui.callbacks.fullscreen_clicked)
        self.create_separator()
        if widget.terminal.Terminal.implemented:
            self.create_xpmitem(graph.xpm.XPMTerminal, _("Terminal"), gui.callbacks.terminal_clicked)
        self.create_item("gtk-preferences", _("Preferences"), gui.callbacks.preferences_clicked)
