# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

if __name__ != '__main__':
    from lib.splash import SplashWindow
    SplashWindow.pulse_text_import('lib.event')

class Events(object):
    def __init__(self):
        self.events_list = {}
        self.objects = {}
        self.groups = {}
    def register_event(self, obj, name):
        if self.events_list.has_key(name):
            raise Exception('Event named \'%s\' already exists' % name)
        self.events_list[name] = []
        self.objects[name] = obj
    def unregister_event(self, name):
        if self.events_list.has_key(name):
            self.events_list.pop(name)
            self.objects.pop(name)
        else:
            raise Exception('Event named \'%s\' doesn\'t exists' % name)
    def connect(self, group, name, callback, callback_data=None):
        if not self.events_list.has_key(name):
            raise Exception('Event \'%s\' isn\'t registered' % name)
        try:
            group_list = self.groups[group]
        except:
            group_list = []
            self.groups[group] = group_list
        group_list.append([name, [callback, callback_data]])
        self.events_list[name].append([callback, callback_data])
    def disconnect(self, group):
        if not self.groups.has_key(group):
            raise Exception('Group \'%s\' doesn\'t exists' % name)
        for x in self.groups[group]:
            self.events_list[x[0]].remove(x[1])
        self.groups.pop(group)
    def emit_event(self, name, param=None):
        if not self.events_list.has_key(name):
            raise Exception('Event \'%s\' isn\'t registered' % name)
        obj = self.objects[name]
        if param==None:
            param = []
        param.insert(0, name)
        for x in self.events_list[name]:
            x[0](obj, param, x[1])

if __name__ == '__main__':
    def print_state(event):
        print '-------------------------------------------------------------'
        print 'EVENT LIST:', event.events_list
        print 'OBJECTS:', event.objects
        print 'GROUPS:', event.groups
    event = Events()
    event.register_event(None, 'conf.test')
    event.register_event(None, 'test')
    print_state(event)
    class X:
        def __init__(self):
            event.connect(self, 'conf.test', self.callback, 'X1')
            event.connect(self, 'test', self.callback, 'X2')
        def callback(self, obj, data):
            print obj, data
    class Y:
        def __init__(self):
            event.connect(self, 'conf.test', self.callback, 'Y1')
            event.connect(self, 'test', self.callback, 'Y2')
        def callback(self, obj, data):
            print obj, data
    x = X()
    y = Y()
    print_state(event)
    event.emit_event('test')
    event.emit_event('conf.test')
    
    event.disconnect(x)
    print_state(event)

    event.emit_event('test')
    event.emit_event('conf.test')
    
    event.disconnect(y)
    print_state(event)

    event.unregister_event('test')
    print_state(event)
