# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from lib.splash import SplashWindow
SplashWindow.pulse_text_import("lib.indent.ast")

(
    END_LINE,
    BIG_COMMENT,
    SMALL_COMMENT,
    FUNCTION,
    PROCEDURE,
    STRING,
    TEXT,
    ARGUMENT
) = range(1, 9)

class Node(object):
    __slots__ = ("type", "indent")
    def __init__(self, type):
        self.type = type
        self.indent = 0

class EndLine(Node):
    def __init__(self):
        Node.__init__(self, END_LINE)

class SmallComment(Node):
    __slots__ = ("comment")
    def __init__(self, comment):
        Node.__init__(self, SMALL_COMMENT)
        self.comment = comment

class BigComment(Node):
    __slots__ = ("comments")
    def __init__(self, comments):
        Node.__init__(self, BIG_COMMENT)
        self.comments = comments

class Function(Node):
    __slots__ = ("rtype", "name", "args")
    def __init__(self, rtype, name, args):
        Node.__init__(self, FUNCTION)
        self.rtype = rtype
        self.name  = name
        self.args  = args

class Procedure(Node):
    __slots__ = ("name", "args")
    def __init__(self, name, args):
        Node.__init__(self, FUNCTION)
        self.name  = name
        self.args  = args

class String(Node):
    __slots__ = ("string")
    def __init__(self, string):
        Node.__init__(self, STRING)
        self.string = string

class Text(Node):
    __slots__ = ("text")
    def __init__(self, text):
        Node.__init__(self, TEXT)
        self.text = text

class Argument(Node):
    __slots__ = ("argument")
    def __init__(self, argument):
        Node.__init__(self, ARGUMENT)
        self.argument = argument
