# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from lib.splash import SplashWindow
SplashWindow.pulse_text_import('lib.indent.options')

(
    BLANK_LINES,
    LONG_LINES,
    DECLARATIONS,
    STATEMANTS,
    COMMENTS,
    INDENTATION,
    MISCELLANEOUS
) = range(1, 8)

list = [['rel', _('Remove empty lines'),        MISCELLANEOUS],
        ['fmc', _('Format multiline comments'), COMMENTS]
    ]

qlist = [['bad'  , _('Blank lines after declarations'),       BLANK_LINES],
        ['bap'  , _('Blank lines after procedures'),         BLANK_LINES],
        ['bbb'  , _('Blank lines before block comments'),    BLANK_LINES],
        ['bbo'  , _('Break before boolean operator'),        LONG_LINES],
        ['bc'   , _('Blank lines after commas'),             DECLARATIONS],
        ['bl '  , _('Braces after if line'),                 STATEMANTS],
#       ['blin' , _('Brace indent n'),                       STATEMANTS],
        ['bls'  , _('Braces after struct decl line'),        DECLARATIONS],
        ['br'   , _('Braces on if line'),                    STATEMANTS],
        ['brs'  , _('Braces on struct decl line'),           DECLARATIONS],
#       ['cn'   , _('Comment indentation n'),                COMMENTS],
#       ['cbin' , _('Case brace indentation n'),             STATEMANTS],
#       ['cdn'  , _('Declaration comment column n'),         COMMENTS],
        ['cdb'  , _('Comment delimiters on blank lines'),    COMMENTS],
        ['cdw'  , _('Cuddle do while'),                      STATEMANTS],
        ['ce'   , _('Cuddle else'),                          STATEMANTS],
#       ['cin'  , _('Continuation indentation n'),           STATEMANTS],
#       ['clin' , _('Case indentation n'),                   STATEMANTS],
#       ['cpn'  , _('Else endif column n'),                  COMMENTS],
        ['cs'   , _('Space after cast'),                     STATEMANTS],
#       ['dn'   , _('Line comments indentation n'),          COMMENTS],
        ['bfda' , _('Break function decl before args'),      DECLARATIONS],
        ['bfde' , _('Break function decl after args'),       DECLARATIONS],
#       ['din'  , _('Declaration indentation n'),            DECLARATIONS],
        ['fc1'  , _('Format first column comments'),         COMMENTS],
        ['fca'  , _('Format all comments'),                  COMMENTS],
        ['hnl'  , _('Honour newlines'),                      LONG_LINES],
#       ['in'   , _('Indent level n'),                       INDENTATION],
#       ['ipn'  , _('Parameter indentation n'),              INDENTATION],
#       ['ln'   , _('Line length n'),                        LONG_LINES],
#       ['lcn'  , 'Comment line length n'),                  COMMENTS],
        ['lp'   , _('Continue at parentheses'),              INDENTATION],
        ['lps'  , _('Leave preprocessor space'),             INDENTATION],
        ['nbad' , _('No blank lines after declarations'),    BLANK_LINES],
        ['nbap' , _('No blank lines after procedures'),      BLANK_LINES],
        ['nbbo' , _('Break after boolean operator'),         LONG_LINES],
        ['nbc'  , _('No blank lines after commas'),          DECLARATIONS],
        ['nbfda', _('Don\'t break function decl args'),      DECLARATIONS],
        ['ncdb' , _('No comment delimiters on blank lines'), COMMENTS],
        ['ncdw' , _('Don\'t cuddle do while'),               STATEMANTS],
        ['nce'  , _('Don\'t cuddle else'),                   STATEMANTS],
        ['ncs'  , _('No space after casts'),                 STATEMANTS],
        ['nfc1' , _('Don\'t format first column comments'),  COMMENTS],
        ['nfca' , _('Don\'t format comments'),               COMMENTS],
        ['nhnl' , _('Ignore newlines'),                      LONG_LINES],
        ['nip'  , _('No parameter indentation'),             INDENTATION],
        ['nlp'  , _('Don\'t line up parentheses'),           STATEMANTS],
        ['npcs' , _('No space after function call names'),   STATEMANTS],
        ['nprs' , _('No space after parentheses'),           STATEMANTS],
        ['npsl' , _('Don\'t break procedure type'),          DECLARATIONS],
        ['nsaf' , _('No space after for'),                   STATEMANTS],
        ['nsai' , _('No space after if'),                    STATEMANTS],
        ['nsaw' , _('No space after while'),                 STATEMANTS],
        ['nsc'  , _('Don\'t star comments'),                 COMMENTS],
        ['nsob' , _('Leave optional blank lines'),           BLANK_LINES],
        ['nss'  , _('Don\'t space special semicolon'),       STATEMANTS],
        ['nut'  , _('No tabs'),                              INDENTATION],
        ['pcs'  , _('Space after procedure calls'),          STATEMANTS],
#       ['pin'  , _('Paren indentation n'),                  STATEMANTS],
        ['prs'  , _('Space after parentheses'),              STATEMANTS],
        ['psl'  , _('Procnames start lines'),                DECLARATIONS],
        ['saf'  , _('Space after for'),                      STATEMANTS],
        ['sai'  , _('Space after if'),                       STATEMANTS],
        ['saw'  , _('Space after while'),                    STATEMANTS],
#       ['sbin' , _('Struct brace indentation n'),           STATEMANTS],
        ['sc'   , _('Start left side of comments'),          COMMENTS],
        ['sob'  , _('Swallow optional blank lines'),         BLANK_LINES],
        ['ss'   , _('Space special semicolon'),              STATEMANTS],
#       ['tsn'  , _('Tab size n'),                           INDENTATION],
        ['ut'   , _('Use tabs'),                             INDENTATION]
    ]
