# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from lib.splash import SplashWindow
SplashWindow.pulse_text_import("lib.proxy")

import types

class ReadOnlyException(Exception):
    def __init__(self, key):
        self.key = key
    def __str__(self):
        return 'The variable \"%s\" is read only' % (self.key)

class StaticProxy(object):
    __slots__ = ('klass')
    def __init__(self, klass):
        if type(klass)==types.ClassType:
            StaticProxy.__dict__['klass'].__set__(self, klass)
        else:
            StaticProxy.__dict__['klass'].__set__(self, klass.__class__)
    def get_dict(self):
        return self.klass.__dict__
    def __getitem__(self, key):
        value = self.klass.__dict__[key]
        if type(value)==types.FunctionType:
            raise KeyError
        return value
    def __setitem__(self, key, item):
        raise ReadOnlyException(key)
    def __getattr__(self, name):
        return self.__getitem__(name)
    def __setattr__(self, name, value):
        raise ReadOnlyException(name)
    def __str__(self):
        dict = {}
        for x in self.klass.__dict__:
            tmp = self.klass.__dict__[x]
            if type(tmp)!=types.FunctionType:
                if x[0]!='_':
                    dict[x] = tmp
        return str(dict)

class ClassProxy(object):
    __slots__ = ('klass')
    def __init__(self, klass):
        if type(klass)==types.ClassType:
            raise AttributeError
        else:
            ClassProxy.__dict__['klass'].__set__(self, klass)
    def get_dict(self):
        return self.klass.__dict__
    def __getitem__(self, key):
        value = self.klass.__dict__[key]
        if type(value)==types.FunctionType:
            raise KeyError
        return value
    def __setitem__(self, key, item):
        raise ReadOnlyException(key)
    def __getattr__(self, name):
        return self.__getitem__(name)
    def __setattr__(self, name, value):
        raise ReadOnlyException(name)
    def __str__(self):
        dict = {}
        for x in self.klass.__dict__:
            tmp = self.klass.__dict__[x]
            if type(tmp)!=types.FunctionType:
                if x[0]!='_':
                    dict[x] = tmp
        return str(dict)


#if __name__=="__main__":
#    class Test:
#        x = 10
#        y = 20
#        z = 30
#        def test(self):
#            pass
#    a = Test()
#    dict = StaticProxy(a)
#    print dict["x"]    
#    print dict.y
#    dict.z = 30
