# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import gtk

__all__ = ["SplashWindow"]

from lib.splash_const import PROGRESSBAR_COUNT

class SplashWindow(gtk.Window):
    """Klasa definiujaca ekran powitalny oraz wyswietlajaca postepy w ladowaniu programu"""
    label        = gtk.Label()
    progress_bar = gtk.ProgressBar()
    counter      = 0.0
    def __init__(self):
        """Konstruktor"""
        gtk.Window.__init__(self, gtk.WINDOW_POPUP)
        self.set_position(gtk.WIN_POS_CENTER)
        self.vbox = gtk.VBox()
        self.vbox.show()
        self.add(self.vbox)
        self.splashscreen = gtk.Image()
        self.splashscreen.set_from_file("graph/splashscreen.png")
        self.splashscreen.show()
        self.vbox.pack_start(self.splashscreen)
        SplashWindow.label.show()
        hbox = gtk.HBox()
        hbox.show()
        hbox.pack_start(SplashWindow.label, False, False, 5)
        self.vbox.pack_start(hbox)
        SplashWindow.progress_bar.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
        SplashWindow.progress_bar.show()
        self.vbox.pack_start(SplashWindow.progress_bar)
    def show(self):
        """Funkcja powoduje wyswietlenie na ekranie tej klasy"""
        gtk.Window.show(self)
        gtk.main_iteration()
    @staticmethod
    def pulse_text(text):
        """
        Funckja statyczna, jest polaczeniem funkcji set_text() i pulse()
        @param text: wyswietlany tekst
        """
        print text
        SplashWindow.set_text(text)
        SplashWindow.pulse()
    @staticmethod
    def pulse_text_import(text):
        """
        Funckja statyczna, ustawia wyswietlany tekst na "Importing: " + text.
        @param text: wyswietlany tekst
        """
        SplashWindow.pulse_text(_("Importing: ") + text)
    @staticmethod
    def pulse_text_plugin_load(text):
        """
        Funckja statyczna, ustawia wyswietlany tekst na "Plugin loading: " + text.
        @param text: wyswietlany tekst
        """
        SplashWindow.pulse_text(_("Plugin loading: ") + text)
    @staticmethod
    def pulse():
        """Funckja statyczna, powoduje zwiekszenie pasku stanu o jedna jednostke"""
        SplashWindow.counter += 1
        SplashWindow.progress_bar.set_fraction(SplashWindow.counter/PROGRESSBAR_COUNT)
        gtk.main_iteration()
    @staticmethod
    def set_text(text):
        """
        Funckja statyczna, ustawia aktualnie wyswietlany tekst
        @param text: wyswietlany tekst
        """
        if len(text) > 50:
            text = text[0:50]
        SplashWindow.label.set_text(text)
        gtk.main_iteration()
    def quit(self):
        """Funckja ta zapisuje do pliku aktualna stala PROGRESSBAR_STEP"""
        if PROGRESSBAR_COUNT != SplashWindow.counter:
            f = open("lib/splash_const.py", "w")
            f.write("PROGRESSBAR_COUNT = ")
            f.write(str(SplashWindow.counter))
            f.write("\n")
            f.close()
        self.hide()
