# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import lib.core

from lib.splash import SplashWindow
SplashWindow.pulse_text_import("lib.tools")

import os
import time
import stat
import pwd
import grp
import gtk

class Size(object):
    __slots__ = ('width', 'height')
    def __init__(self, width, height):
        self.width = width
        self.height = height
    def __str__(self):
        return 'Size=(%i, %i)' % (self.width, self.height)

def create_file_filter(name, pattern):
    filt = gtk.FileFilter()
    filt.set_name(name)
    filt.add_pattern(pattern)
    return filt

def convert_file_mode(st_mode):
    mode = stat.S_IMODE(st_mode)
    if mode & 0x100:
        str_mode = "r"
    else:
        str_mode = "-"
    if mode & 0x080:
        str_mode += "w"
    else:
        str_mode += "-"
    if mode & 0x040:
        str_mode += "x"
    else:
        str_mode += "-"
    if mode & 0x020:
        str_mode += "r"
    else:
        str_mode += "-"
    if mode & 0x010:
        str_mode += "w"
    else:
        str_mode += "-"
    if mode & 0x008:
        str_mode += "x"
    else:
        str_mode += "-"
    if mode & 0x004:
        str_mode += "r"
    else:
        str_mode += "-"
    if mode & 0x002:
        str_mode += "w"
    else:
        str_mode += "-"
    if mode & 0x001:
        str_mode += "x"
    else:
        str_mode += "-"
    return str_mode    

def get_file_type(file_name):
    l = len(file_name)
    ftype = (None, _('Unknown'))
    for x in lib.core.share_data.get_data('syntax.re.list'):
        if x[0] == None:
            ftype = x
        elif x[0].search(file_name):
            ftype = x
            break            
    return ftype

def get_file_info(file_name):
    s = file_name.split('/')
    st_mode, st_ino, st_dev, st_nlink, st_uid, st_gid, st_size, st_atime, st_mtime, st_ctime = os.stat(file_name)
    if st_size < 1024:
        size = "%i B" % st_size
    elif st_size < 1048576:
        size = "%i KB" % (st_size / 1024)
    else:
        size = "%i MB" % (st_size / 1048576)
    str_mtime = time.ctime(st_mtime)
    str_owner = pwd.getpwuid(st_uid)[0] + ":"
    str_owner += grp.getgrgid(st_gid)[0]
    return (file_name.strip(s[-1]), s[-1], get_file_type(file_name)[1], size, str_mtime, str_owner, convert_file_mode(st_mode))

def get_file_time(file_name):
    st_mode, st_ino, st_dev, st_nlink, st_uid, st_gid, st_size, st_atime, st_mtime, st_ctime = os.stat(file_name)
    return st_mtime

def get_full_path(file_name):
    fn = ''
    fp = ''
    if file_name[0] == '/':
        s = file_name.split('/')
        fn = s[-1]
        fp = file_name[0:file_name.rfind('/')] + '/'
        if fp == '':
            fp = '/'
    else:
        fn = file_name
        fp = os.getcwd() + '/'
    return (fp, fn)
