#!/usr/bin/python
# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrbore@op.pl
#
#	Copyright 2006 Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

def __msg(msg):
    return msg

import __builtin__
__builtin__.__dict__['_'] = __msg

import sys
try:
    import gtk
except:
    print """Didn't find pygtk module (www.pygtk.org). Please install it before running this application"""
    sys.exit(-1)

try:
    import cairo
except:
    print """Didn't find pycairok module. Please install it before running this application"""
    sys.exit(-1)

try:
    import vte
except:
    print """Didn't find vte-python module. Please install it before running this application"""

def check_version(major, minor, patch, version):
    v = version.split('.')
    v[0] = int(v[0])
    v[1] = int(v[1])
    v[2] = int(v[2])
    if major > v[0]:
        return True
    elif major == v[0]:
        if minor > v[1]:
            return True
        elif minor == v[1]:
            if patch >= v[2]:
                return True
    return False

major, minor, patch = gtk.pygtk_version
print "Checking pygtk version: %i.%i.%i" % (major, minor, patch)
if check_version(major, minor, patch, '2.8.0'):
    print "Require 2.8.0 :  OK"
else:
    print "Require 2.8.0 :  FAIL"
    sys.exit(-1)

major, minor, patch = cairo.version.split('.')
major = int(major)
minor = int(minor)
patch = int(patch)
print "Checking pycairo version: %i.%i.%i" % (major, minor, patch)
if check_version(major, minor, patch, '1.2.0'):
    print "Require 1.2.0 :  OK"
else:
    print "Require 1.2.0 :  FAIL"
    sys.exit(-1)

from lib.splash import SplashWindow

splash = SplashWindow()
splash.show()

import lib.core
import gui.main_gui

def run():
    lib.core.init_core()
    gui.main_gui.init_gui()
    gui.main_gui.app.init_syntax()
    splash.pulse_text('Creating gui')
    gui.main_gui.app.create_gui()
    splash.quit()
    gui.main_gui.app.main()

if __name__ == '__main__':
    run()
