# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import lib.syntax.property
from lib.syntax.flags import *
from lib.syntax.template import *

CHARACTERS         = '_qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM'
SPECIAL_CHARACTERS = ' \t\n=\"\'~!@#$%^&*()-+[]{}\|;:,.<>/?'
g                  = globals()

def init():
    p = lib.syntax.property.init('PO', 'po.py', r"^.*\.po$")
    p.create_attr('Text')
    p.create_attr('Background')
    p.create_attr('Keyword')
    p.create_attr('SpecialKeyword1')
    p.create_attr('SpecialKeyword2')
    p.create_attr('Text2')
    p.create_attr('Comment')
    p.create_attr('FormatString')
    p.end_init()
    p.create_view("""# Comment
#, fuzzy
\"Content-Type: text/plain; charset=UTF-8\"

#: conf/base.py:63
msgid \"Testing: %s\"
msgstr \"\"""")

create_idle(g,
    list = [[CHARACTERS,          'KeywordState',      'Text',        FLAGS_NOEAT],
            ['#',                 'BeginCommentState', 'Comment',     FLAGS_NOEAT],
    ]
)
create_comment       (g, 'TextState1',         'IdleState', '\'',               '\'', color = 'Text2')
create_comment       (g, 'CommentState1',      'IdleState', '#:',               '\n', color = 'SpecialKeyword2', append=False)
create_comment       (g, 'CommentState2',      'IdleState', '#,',               '\n', color = 'SpecialKeyword2', append=False)
create_comment       (g, 'CommentState3',      'IdleState', '#',                '\n', append=False) 
create_wait_for_noeat(g, 'UselesscharState'  , 'IdleState', SPECIAL_CHARACTERS,       any_color='Text')
create_c_text        (g, 'TextState2',         'IdleState', 'dDiouxXfegEascpn')

class BeginCommentState:
    type = TYPE_STR
    any  = ['IdleState', None, FLAGS_NONE]
    list = [['#, fuzzy', 'BeginInfoState', 'SpecialKeyword1', FLAGS_NONE],
            ['#:',       'CommentState1',   None,             FLAGS_NOEAT],
            ['#,',       'CommentState2',   None,             FLAGS_NOEAT],
            ['#',        'CommentState3',   None,             FLAGS_NOEAT]
        ]

class KeywordState:
    type = TYPE_STR
    any  = ['UselesscharState', 'Text', FLAGS_NONE]
    # Very important !!! Sort this list !!!
    # Longer strings put on the start of the list,
    # and shorter strings put on the end of the list !!!
    list = [['msgstr ', 'CheckKeywordState', 'Keyword', FLAGS_BUFFER],
            ['msgid ',  'CheckKeywordState', 'Keyword', FLAGS_BUFFER],
        ]

class CheckKeywordState:
    type = TYPE_STR
    any  = ['TextState2', None, FLAGS_FLUSH]
    list = [['\"\"', 'IdleState',        'SpecialKeyword1', FLAGS_NONE],
            [' ',    'CheckKeywordState', None,             FLAGS_BUFFER],
            ['\"',   'TextState2',        None,             FLAGS_FLUSH]
        ]

class BeginInfoState:
    type = TYPE_CHAR
    any  = ['BeginInfoState', None, FLAGS_NONE]
    list = [['\n', 'EndInfoState', None, FLAGS_NONE]
        ]

class EndInfoState:
    type = TYPE_CHAR
    any  = ['BeginInfoState', None, FLAGS_NONE]
    list = [['\n', 'IdleState', 'Text', FLAGS_NONE]
        ]
