# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import lib.encodings

from lib.splash import SplashWindow
SplashWindow.pulse_text_import('widget.combobox')

import gtk
import gobject

class EncComboBox(gtk.ComboBox):
    def __init__(self):
        self.model = self.create_model()
        gtk.ComboBox.__init__(self, self.model)
        cell = gtk.CellRendererText()
        self.pack_start(cell, False)
        self.add_attribute(cell, 'text', 0)
        self.set_cell_data_func(cell, self.is_sensitive)
        self.connect("changed", self.changed_event)
        self.active = None
    def get_active(self):
        return self.active
    def set_active(self, active):
        model = self.get_model()
        iter = model.get_iter_root()
        while iter:
            child = model.iter_children(iter)
            while child:
                value = model.get_value(child, 0)
                if value == active:
                    self.active = active
                    self.set_active_iter(child)
                    return
                child = model.iter_next(child)
            iter = model.iter_next(iter)
    def is_sensitive(self, celllayout, cell, model, iter, data=None):
        cell.set_property("sensitive", not model.iter_has_child(iter))
    def create_model(self):
        model = gtk.TreeStore(gobject.TYPE_STRING)
        for key, value in lib.encodings.enc_group:
            iter = model.append(None, [key])
            for x in value:
                model.append(iter, [x])
        return model
    def changed_event(self, combobox, data=None):
        model = self.get_model()
        iter = self.get_active_iter()
        self.active = model.get_value(iter, 0)
