# -*- coding: iso-8859-2 -*-

#	Programmer:	Piotr Borek
#	E-mail:		piotrborek@op.pl
#
#	Copyright 2006  Piotr Borek
#
#	Distributed under the terms of the GPL (GNU Public License)
#
#    pyX4 is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import lib.tools
import lib.core
import widget.combobox

from lib.splash import SplashWindow
SplashWindow.pulse_text_import('widget.filedialog')

import gtk

OPEN_DIALOG = 1
SAVE_DIALOG = 2

class FileDialog(gtk.FileChooserDialog):
    def __init__(self, title=None, parent=None, action=gtk.FILE_CHOOSER_ACTION_OPEN, buttons=None, backend=None):
        if action == gtk.FILE_CHOOSER_ACTION_OPEN:
            b = ('gtk-open', gtk.RESPONSE_ACCEPT, 'gtk-cancel', gtk.RESPONSE_DELETE_EVENT)
            gtk.FileChooserDialog.__init__(self, _("Open a file"), parent, action, b)
        elif action == gtk.FILE_CHOOSER_ACTION_SAVE:
            b = ('gtk-save', gtk.RESPONSE_ACCEPT, 'gtk-cancel', gtk.RESPONSE_DELETE_EVENT)
            gtk.FileChooserDialog.__init__(self, _("Save a file"), parent, action, b)
        self.add_filter(lib.tools.create_file_filter(_('All'), '*'))
        self.add_filter(lib.tools.create_file_filter('Python', '*.py'))
        self.add_filter(lib.tools.create_file_filter('Perl', '*.pl'))
        self.add_filter(lib.tools.create_file_filter('C/C++', '*.[ch]*'))
        self.add_filter(lib.tools.create_file_filter('C#', '*.cs'))
        self.hbox = gtk.HBox()
        self.hbox.show()
        self.vbox.pack_start(self.hbox, False, False)
        self.checkbutton = gtk.CheckButton(_("Show hidden files"))
        self.checkbutton.show()
        self.checkbutton.connect('toggled', self.button_toggled)
        self.hbox.pack_start(self.checkbutton, True, True)
        self.combobox = widget.combobox.EncComboBox()
        p = lib.core.share_data.get_data('conf.editor.general')
        self.combobox.set_active(p.encoding)
        self.combobox.show()
        self.hbox.pack_start(self.combobox, False, False)
        self.set_show_hidden(False)
    def get_encoding(self):
        return self.combobox.get_active()
    def set_show_hidden(self, show_hidden):
        self.checkbutton.set_active(show_hidden)
        gtk.FileChooserDialog.set_show_hidden(self, show_hidden)
    def button_toggled(self, toggle_button, data=None):
        gtk.FileChooserDialog.set_show_hidden(self, toggle_button.get_active())
